#include "stdio.h"     
#include "unistd.h"    
#include "sys/ioctl.h"
#include "fcntl.h"     
#include "time.h"     
#include "asm/etraxgpio.h"

#define LED_1  1<<25
#define LED_2  1<<24
#define LED_3  1<<0

#define IO_SETGET_OUTPUT  0x13

int main(void) {
  int fda;
  int fdg;
  int iomask_a;
  int iomask_b;
  int iomask_g;
  int i;
  
  if ((fda = open("/dev/gpioa", O_RDWR))<0) {
    printf("ERRORE nell'apertura di /dev/gpioa\n");
    return 1;
  }
  if ((fdg = open("/dev/gpiog", O_RDWR))<0) {
    printf("ERRORE nell'apertura di /dev/gpiog\n");
    return 1;
  }
  iomask_a = LED_3;
  ioctl(fda, _IO(ETRAXGPIO_IOCTYPE, IO_SETGET_OUTPUT),&iomask_a);
  iomask_g = LED_1 | LED_2;
  ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETGET_OUTPUT),&iomask_g);

  while (1) {
    printf("Test LED\n");
    ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETBITS),LED_1);  //LED 1 ON
    sleep(1);
    ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),LED_1);  //LED 1 OFF
    sleep(1);
    ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETBITS),LED_2);
    sleep(1);
    ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),LED_2);
    sleep(1);
    ioctl(fda, _IO(ETRAXGPIO_IOCTYPE, IO_SETBITS),LED_3);
    sleep(1);
    ioctl(fda, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),LED_3);
    sleep(1);
  }  
  
  close(fda);
  close(fdg);
  return 0;
}
